---
- name: Install prerequisites
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - curl
    - wget
    - vim
    - software-properties-common
    - dirmngr
    - apt-transport-https
    - ca-certificates
    - lsb-release
    - debian-archive-keyring
    - gnupg2
    - ufw
    - unzip

- name: Copy depots grafana telegraf
  copy:
    src: ../roles/monitoring/grafana/files/depots.sh
    dest: /usr/local/bin/depots.sh
    owner: debian
    group: debian   
    mode: '0755'
  notify:
    - Run import depots

- meta: flush_handlers

- name: Install Grafana and Telegraf
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - grafana
    - telegraf

- name: Start Grafana
  service:
    name: grafana-server
    state: started
    enabled: yes

- name: Add line to rsyslog.conf
  lineinfile:
    path: /etc/rsyslog.conf
    line: "*.* @@(o)127.0.0.1:6514;RSYSLOG_SyslogProtocol23Format"
    insertafter: EOF

- name: Restart rsyslog service
  service:
    name: rsyslog
    state: restarted

- name: Copy conf telegraf
  copy:
    src: ../roles/monitoring/grafana/files/telegraf.conf
    dest: /etc/telegraf/telegraf.conf
    mode: '0644'

- name: Start Telegraf service
  service:
    name: telegraf
    state: started
    enabled: yes

- name: Enable services at boot
  systemd:
    name: "{{ item }}"
    enabled: yes
  loop:
    - telegraf
    - grafana-server

### Depots pour filebeat & metricbeat ###

- name: Import Elasticsearch GPG key
  apt_key:
    url: https://artifacts.elastic.co/GPG-KEY-elasticsearch

- name: Add Elastic APT repository
  apt_repository:
    repo: deb https://artifacts.elastic.co/packages/8.x/apt stable main
    state: present

- name: Update apt cache
  apt:
    update_cache: yes

### Install filebeat & metricbeat ###
- name: Installation des paquets requis
  apt:
    name: "{{ item }}"
    state: present
  loop:
    - filebeat
    - metricbeat

### Conf filebeat ###
- name: Copy filebeat.yml
  copy:
    src: ../roles/monitoring/grafana/files/filebeat.yml
    dest: /etc/filebeat/filebeat.yml
    owner: root
    group: root   
    mode: '0600'

- name: Copy module system.yml
  copy:
    src: ../roles/monitoring/grafana/files/filebeat_modules.d/system.yml
    dest: /etc/filebeat/modules.d/system.yml
    owner: root
    group: root   
    mode: '0644'

- name: Setup system module for Filebeat
  ansible.builtin.command: filebeat setup

### Conf metricbeat ###
- name: Copy metricbeat.yml
  copy:
    src: ../roles/monitoring/grafana/files/metricbeat.yml
    dest: /etc/metricbeat/metricbeat.yml
    owner: root
    group: root   
    mode: '0600'

- name: Copy module linux.yml
  copy:
    src: ../roles/monitoring/grafana/files/metricbeat_modules.d/linux.yml
    dest: /etc/metricbeat/modules.d/linux.yml
    owner: root
    group: root   
    mode: '0644'

- name: Setup linux module for Metricbeat
  ansible.builtin.command: metricbeat setup

- name: Enable services at boot
  systemd:
    name: "{{ item }}"
    enabled: yes
  loop:
    - filebeat
    - metricbeat

- name: Start services
  service:
    name: "{{ item }}"
    state: started
    enabled: yes
  loop:
    - filebeat
    - metricbeat
